#include <stdarg.h>
#include <gtk/gtk.h>


static int result;


gboolean cb_modal_dialog_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	result = 0;
	gtk_main_quit();
	return TRUE;
}


void cb_modal_dialog_button_clicked(GtkButton *button, gpointer data)
{
	result = (int)data;
	gtk_main_quit();
}


int modal_dialog(GtkWindow *transientfor, char *title, char* text, int defbutton, int nbuttons, ...)
{
	va_list ap;
	GtkWidget *dlg, *label, *bbox, *button;
	int i;

	/* create the dialog */
	dlg = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dlg), title);
	gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	if (transientfor != NULL)
		gtk_window_set_transient_for(GTK_WINDOW(dlg), transientfor);
	gtk_signal_connect(GTK_OBJECT(dlg), "delete_event",
			   GTK_SIGNAL_FUNC(cb_modal_dialog_delete_event), NULL);

	label = gtk_label_new(text);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_misc_set_padding(GTK_MISC(label), 25, 25);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->vbox), label);

	bbox = gtk_hbutton_box_new();
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 10);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->action_area), bbox);

	/* add the buttons */
	va_start(ap, nbuttons);
	for (i = 0; i < nbuttons; i++) {
		button = gtk_button_new_with_label(va_arg(ap, char *));
		gtk_signal_connect(GTK_OBJECT(button), "clicked",
				   cb_modal_dialog_button_clicked, (gpointer)(i+1));
		gtk_container_add(GTK_CONTAINER(bbox), button);

		gtk_object_set(GTK_OBJECT(button), "can_default", TRUE, NULL);
		if (defbutton == i+1)
			gtk_widget_grab_default(button);
	}
	va_end(ap);

	/* show the dialog and wait for it to finish by entering gtk_main */
	result = 0;
	gtk_widget_show_all(dlg);
	gtk_main();

	/* cleanup and return the button pressed */
	gtk_widget_destroy(dlg);
	return result;
}

